/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.24 Revision 1.62
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.24 2005/04/12 12:28:14 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.62 2009/09/06 22:54:58 robbat2 Exp $
4# 4#
5# Description: This eclass is used as a central eclass for accessing kernel
6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
10#
11# Maintainer: John Mylchreest <johnm@gentoo.org> 5# Original author: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux 6# Maintainer: kernel-misc@gentoo.org
13# 7#
14# Please direct your bugs to the current eclass maintainer :) 8# Please direct your bugs to the current eclass maintainer :)
9
10# @ECLASS: linux-info.eclass
11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
15 24
16# A Couple of env vars are available to effect usage of this eclass 25# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 26# These are as follows:
18# 27
19# Env Var Option Description 28# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> The directory containing kernel the target kernel 29# @DESCRIPTION:
21# sources. 30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
22# CONFIG_CHECK <string> a list of .config options to check for before 35# A string containing a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR" 36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
24# You can also check that an option doesn't exist by 40# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!). 41# prepending it with an exclamation mark (!).
42#
26# ie: CONFIG_CHECK="!MTRR" 43# e.g.: CONFIG_CHECK="!MTRR"
27# ERROR_CFG <string> The error message to display when the above check 44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
28# fails. <CFG> should reference the appropriate option 58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
29# as above. ie: MTRR_ERROR="MTRR exists in the .config 59#
30# but shouldn't!!" 60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from 61
32# the kernel makefile. This contains the directory 62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
33# which is to be used as the kernel object directory. 65# which is to be used as the kernel object directory.
34 66
35# There are also a couple of variables which are set by this, and shouldn't be 67# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows: 68# set by hand. These are as follows:
37# 69
38# Env Var Option Description 70# @ECLASS-VARIABLE: KV_FULL
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1 71# @DESCRIPTION:
40# KV_MAJOR <integer> The kernel major version. ie: 2 72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
41# KV_MINOR <integer> The kernel minor version. ie: 6 73
42# KV_PATCH <integer> The kernel patch version. ie: 9 74# @ECLASS-VARIABLE: KV_MAJOR
43# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo 75# @DESCRIPTION:
44# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm 76# A read-only variable. It's an integer containing the kernel major version. ie: 2
45# KV_DIR <string> The kernel source directory, will be null if 77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
46# KERNEL_DIR is invalid. 97# KERNEL_DIR is invalid.
47# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless 98
48# koutput is used. This should be used for referencing 99# @ECLASS-VARIABLE: KV_OUT_DIR
49# .config. 100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
50 107
51# And to ensure all the weirdness with crosscompile 108# And to ensure all the weirdness with crosscompile
52inherit toolchain-funcs versionator 109inherit toolchain-funcs versionator
53 110
54ECLASS=linux-info
55INHERITED="$INHERITED $ECLASS"
56EXPORT_FUNCTIONS pkg_setup 111EXPORT_FUNCTIONS pkg_setup
112
113DEPEND="kernel_linux? ( virtual/linux-sources )"
114RDEPEND=""
57 115
58# Overwritable environment Var's 116# Overwritable environment Var's
59# --------------------------------------- 117# ---------------------------------------
60KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}" 118KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
61 119
62 120
63# Bug fixes 121# Bug fixes
64# fix to bug #75034 122# fix to bug #75034
65case ${ARCH} in 123case ${ARCH} in
66 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 124 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
67 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 125 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
68esac 126esac
69 127
70# These are legacy wrappers for toolchain-funcs. 128# @FUNCTION: set_arch_to_kernel
71# I dont like them here, but oh well. 129# @DESCRIPTION:
130# Set the env ARCH to match what the kernel expects.
72set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; } 131set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
132# @FUNCTION: set_arch_to_portage
133# @DESCRIPTION:
134# Set the env ARCH to match what portage expects.
73set_arch_to_portage() { export ARCH="$(tc-arch)"; } 135set_arch_to_portage() { export ARCH=$(tc-arch); }
74 136
75# qeinfo "Message" 137# qeinfo "Message"
76# ------------------- 138# -------------------
77# qeinfo is a quiet einfo call when EBUILD_PHASE 139# qeinfo is a quiet einfo call when EBUILD_PHASE
78# should not have visible output. 140# should not have visible output.
79qout() { 141qout() {
80 local outputmsg type 142 local outputmsg type
81 type=${1} 143 type=${1}
82 shift 144 shift
83 outputmsg="${@}" 145 outputmsg="${@}"
84 case "${EBUILD_PHASE}" in 146 case "${EBUILD_PHASE}" in
85 depend) unset outputmsg;; 147 depend) unset outputmsg;;
86 clean) unset outputmsg;; 148 clean) unset outputmsg;;
87 preinst) unset outputmsg;; 149 preinst) unset outputmsg;;
88 esac 150 esac
89 [ -n "${outputmsg}" ] && ${type} "${outputmsg}" 151 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
90} 152}
91 153
92qeinfo() { qout einfo "${@}" ; } 154qeinfo() { qout einfo "${@}" ; }
93qeerror() { qout eerror "${@}" ; } 155qeerror() { qout eerror "${@}" ; }
94 156
95# File Functions 157# File Functions
96# --------------------------------------- 158# ---------------------------------------
97 159
98# getfilevar accepts 2 vars as follows: 160# @FUNCTION: getfilevar
99# getfilevar <VARIABLE> <CONFIGFILE> 161# @USAGE: variable configfile
100 162# @RETURN: the value of the variable
163# @DESCRIPTION:
164# It detects the value of the variable defined in the file configfile. This is
165# done by including the configfile, and printing the variable with Make.
166# It WILL break if your makefile has missing dependencies!
101getfilevar() { 167getfilevar() {
102local ERROR workingdir basefname basedname myARCH="${ARCH}" 168local ERROR basefname basedname myARCH="${ARCH}"
103 ERROR=0 169 ERROR=0
104 170
105 [ -z "${1}" ] && ERROR=1 171 [ -z "${1}" ] && ERROR=1
106 [ ! -f "${2}" ] && ERROR=1 172 [ ! -f "${2}" ] && ERROR=1
107 173
109 then 175 then
110 echo -e "\n" 176 echo -e "\n"
111 eerror "getfilevar requires 2 variables, with the second a valid file." 177 eerror "getfilevar requires 2 variables, with the second a valid file."
112 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 178 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
113 else 179 else
114 workingdir=${PWD}
115 basefname=$(basename ${2}) 180 basefname="$(basename ${2})"
116 basedname=$(dirname ${2}) 181 basedname="$(dirname ${2})"
117 unset ARCH 182 unset ARCH
118 183
119 cd ${basedname} 184 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
120 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 185 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
121 make ${BUILD_FIXES} -s -f - e 2>/dev/null
122 cd ${workingdir}
123 186
124 ARCH=${myARCH} 187 ARCH=${myARCH}
125 fi 188 fi
126} 189}
127 190
191# @FUNCTION: getfilevar_noexec
192# @USAGE: variable configfile
193# @RETURN: the value of the variable
194# @DESCRIPTION:
195# It detects the value of the variable defined in the file configfile.
196# This is done with sed matching an expression only. If the variable is defined,
197# you will run into problems. See getfilevar for those cases.
198getfilevar_noexec() {
199 local ERROR basefname basedname mycat myARCH="${ARCH}"
200 ERROR=0
201 mycat='cat'
202
203 [ -z "${1}" ] && ERROR=1
204 [ ! -f "${2}" ] && ERROR=1
205 [ "${2#.gz}" != "${2}" ] && mycat='zcat'
206
207 if [ "${ERROR}" = 1 ]
208 then
209 echo -e "\n"
210 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
211 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
212 else
213 ${mycat} "${2}" | \
214 sed -n \
215 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
216 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
217 s,[[:space:]]*\$,,g ;
218 p
219 }"
220 fi
221}
222
223
224# @FUNCTION: linux_config_src_exists
225# @RETURN: true or false
226# @DESCRIPTION:
227# It returns true if .config exists in a build directory otherwise false
228linux_config_src_exists() {
229 [ -s "${KV_OUT_DIR}/.config" ]
230}
231
232# @FUNCTION: linux_config_bin_exists
233# @RETURN: true or false
234# @DESCRIPTION:
235# It returns true if .config exists in /proc, otherwise false
236linux_config_bin_exists() {
237 [ -s "/proc/config.gz" ]
238}
239
240# @FUNCTION: linux_config_exists
241# @RETURN: true or false
242# @DESCRIPTION:
243# It returns true if .config exists otherwise false
244#
245# This function MUST be checked before using any of the linux_chkconfig_*
246# functions.
247linux_config_exists() {
248 linux_config_src_exists || linux_config_bin_exists
249}
250
251# @FUNCTION: require_configured_kernel
252# @DESCRIPTION:
253# This function verifies that the current kernel is configured (it checks against the existence of .config)
254# otherwise it dies.
255require_configured_kernel() {
256 if ! linux_config_src_exists; then
257 qeerror "Could not find a usable .config in the kernel source directory."
258 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
259 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
260 qeerror "it points to the necessary object directory so that it might find .config."
261 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
262 fi
263}
264
265# @FUNCTION: linux_chkconfig_present
266# @USAGE: option
267# @RETURN: true or false
268# @DESCRIPTION:
269# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
270# If linux_config_exists returns false, the results of this are UNDEFINED. You
271# MUST call linux_config_exists first.
128linux_chkconfig_present() { 272linux_chkconfig_present() {
129local RESULT 273local RESULT
274 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
275 local config
276 config="${KV_OUT_DIR}/.config"
277 [ ! -f "${config}" ] && config="/proc/config.gz"
130 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 278 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
131 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 279 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
132} 280}
133 281
282# @FUNCTION: linux_chkconfig_module
283# @USAGE: option
284# @RETURN: true or false
285# @DESCRIPTION:
286# It checks that CONFIG_<option>=m is present in the current kernel .config
287# If linux_config_exists returns false, the results of this are UNDEFINED. You
288# MUST call linux_config_exists first.
134linux_chkconfig_module() { 289linux_chkconfig_module() {
135local RESULT 290local RESULT
291 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
292 local config
293 config="${KV_OUT_DIR}/.config"
294 [ ! -f "${config}" ] && config="/proc/config.gz"
136 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 295 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
137 [ "${RESULT}" = "m" ] && return 0 || return 1 296 [ "${RESULT}" = "m" ] && return 0 || return 1
138} 297}
139 298
299# @FUNCTION: linux_chkconfig_builtin
300# @USAGE: option
301# @RETURN: true or false
302# @DESCRIPTION:
303# It checks that CONFIG_<option>=y is present in the current kernel .config
304# If linux_config_exists returns false, the results of this are UNDEFINED. You
305# MUST call linux_config_exists first.
140linux_chkconfig_builtin() { 306linux_chkconfig_builtin() {
141local RESULT 307local RESULT
308 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
309 local config
310 config="${KV_OUT_DIR}/.config"
311 [ ! -f "${config}" ] && config="/proc/config.gz"
142 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 312 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
143 [ "${RESULT}" = "y" ] && return 0 || return 1 313 [ "${RESULT}" = "y" ] && return 0 || return 1
144} 314}
145 315
316# @FUNCTION: linux_chkconfig_string
317# @USAGE: option
318# @RETURN: CONFIG_<option>
319# @DESCRIPTION:
320# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
321# If linux_config_exists returns false, the results of this are UNDEFINED. You
322# MUST call linux_config_exists first.
146linux_chkconfig_string() { 323linux_chkconfig_string() {
324 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
325 local config
326 config="${KV_OUT_DIR}/.config"
327 [ ! -f "${config}" ] && config="/proc/config.gz"
147 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 328 getfilevar_noexec "CONFIG_${1}" "${config}"
148} 329}
149 330
150# Versioning Functions 331# Versioning Functions
151# --------------------------------------- 332# ---------------------------------------
152 333
153# kernel_is returns true when the version is the same as the passed version 334# @FUNCTION: kernel_is
335# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
336# @RETURN: true or false
337# @DESCRIPTION:
338# It returns true when the current kernel version satisfies the comparison against the passed version.
339# -eq is the default comparison.
154# 340#
341# @CODE
155# For Example where KV = 2.6.9 342# For Example where KV = 2.6.9
156# kernel_is 2 4 returns false 343# kernel_is 2 4 returns false
157# kernel_is 2 returns true 344# kernel_is 2 returns true
158# kernel_is 2 6 returns true 345# kernel_is 2 6 returns true
159# kernel_is 2 6 8 returns false 346# kernel_is 2 6 8 returns false
160# kernel_is 2 6 9 returns true 347# kernel_is 2 6 9 returns true
161# 348# @CODE
349
162# got the jist yet? 350# got the jist yet?
163 351
164kernel_is() { 352kernel_is() {
165 # if we haven't determined the version yet, we need too. 353 # if we haven't determined the version yet, we need to.
166 get_version; 354 get_version
167 local operator test value x=0 y=0 z=0 355 local operator test value x=0 y=0 z=0
168 356
169 case ${1} in 357 case ${1} in
170 lt) operator="-lt"; shift;; 358 lt) operator="-lt"; shift;;
171 gt) operator="-gt"; shift;; 359 gt) operator="-gt"; shift;;
188 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done; 376 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
189 test="${test}${KV_PATCH}";; 377 test="${test}${KV_PATCH}";;
190 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 378 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
191 esac 379 esac
192 done 380 done
193 381
194 [ ${test} ${operator} ${value} ] && return 0 || return 1 382 [ ${test} ${operator} ${value} ] && return 0 || return 1
195} 383}
196 384
385get_localversion() {
386 local lv_list i x
387
388 # ignore files with ~ in it.
389 for i in $(ls ${1}/localversion* 2>/dev/null); do
390 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
391 done
392
393 for i in ${lv_list}; do
394 x="${x}$(<${i})"
395 done
396 x=${x/ /}
397 echo ${x}
398}
399
400# @FUNCTION: get_version
401# @DESCRIPTION:
402# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
403# (if KV_FULL is already set it does nothing).
404#
405# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
406#
407# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
408# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
409# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
197get_version() { 410get_version() {
198 local kbuild_output 411 local kbuild_output
199 412
200 # no need to execute this twice assuming KV_FULL is populated. 413 # no need to execute this twice assuming KV_FULL is populated.
201 # we can force by unsetting KV_FULL 414 # we can force by unsetting KV_FULL
202 [ -n "${KV_FULL}" ] && return 0 415 [ -n "${KV_FULL}" ] && return 0
203 416
204 # if we dont know KV_FULL, then we need too. 417 # if we dont know KV_FULL, then we need too.
207 420
208 # KV_DIR will contain the full path to the sources directory we should use 421 # KV_DIR will contain the full path to the sources directory we should use
209 qeinfo "Determining the location of the kernel source code" 422 qeinfo "Determining the location of the kernel source code"
210 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 423 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
211 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 424 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
212 425
213 if [ -z "${KV_DIR}" ] 426 if [ -z "${KV_DIR}" ]
214 then 427 then
215 qeerror "Unable to find kernel sources at ${KERNEL_DIR}" 428 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
216 qeinfo "This package requires Linux sources." 429 qeinfo "This package requires Linux sources."
217 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then 430 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
231 then 444 then
232 qeerror "Could not find a Makefile in the kernel source directory." 445 qeerror "Could not find a Makefile in the kernel source directory."
233 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 446 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
234 return 1 447 return 1
235 fi 448 fi
236 449
237 # OK so now we know our sources directory, but they might be using 450 # OK so now we know our sources directory, but they might be using
238 # KBUILD_OUTPUT, and we need this for .config and localversions-* 451 # KBUILD_OUTPUT, and we need this for .config and localversions-*
239 # so we better find it eh? 452 # so we better find it eh?
240 # do we pass KBUILD_OUTPUT on the CLI? 453 # do we pass KBUILD_OUTPUT on the CLI?
241 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 454 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
242 455
243 # And if we didn't pass it, we can take a nosey in the Makefile 456 # And if we didn't pass it, we can take a nosey in the Makefile
244 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 457 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
245 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 458 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
246 459
247 # And contrary to existing functions I feel we shouldn't trust the 460 # And contrary to existing functions I feel we shouldn't trust the
248 # directory name to find version information as this seems insane. 461 # directory name to find version information as this seems insane.
249 # so we parse ${KV_DIR}/Makefile 462 # so we parse ${KV_DIR}/Makefile
250 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 463 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
251 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 464 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
252 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 465 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
253 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 466 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
254 467
255 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 468 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
256 then 469 then
257 qeerror "Could not detect kernel version." 470 qeerror "Could not detect kernel version."
258 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 471 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
259 return 1 472 return 1
260 fi 473 fi
261 474
262 # and in newer versions we can also pull LOCALVERSION if it is set. 475 # and in newer versions we can also pull LOCALVERSION if it is set.
263 # but before we do this, we need to find if we use a different object directory. 476 # but before we do this, we need to find if we use a different object directory.
264 # This *WILL* break if the user is using localversions, but we assume it was 477 # This *WILL* break if the user is using localversions, but we assume it was
265 # caught before this if they are. 478 # caught before this if they are.
266 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \ 479 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
267 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}" 480 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
268 481
269 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})" 482 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
270 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 483 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
271 if [ -n "${KV_OUT_DIR}" ]; 484 if [ -n "${KV_OUT_DIR}" ];
272 then 485 then
273 qeinfo "Found kernel object directory:" 486 qeinfo "Found kernel object directory:"
274 qeinfo " ${KV_OUT_DIR}" 487 qeinfo " ${KV_OUT_DIR}"
275 488
276 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)" 489 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
277 fi 490 fi
278 # and if we STILL haven't got it, then we better just set it to KV_DIR 491 # and if we STILL have not got it, then we better just set it to KV_DIR
279 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 492 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
280 493
281 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)" 494 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
495 if linux_config_exists; then
282 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 496 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
283 KV_LOCAL="${KV_LOCAL//\"/}" 497 KV_LOCAL="${KV_LOCAL//\"/}"
498
499 # For things like git that can append extra stuff:
500 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
501 linux_chkconfig_builtin LOCALVERSION_AUTO &&
502 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
503 fi
284 504
285 # And we should set KV_FULL to the full expanded version 505 # And we should set KV_FULL to the full expanded version
286 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 506 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
287 507
288 qeinfo "Found sources for kernel version:" 508 qeinfo "Found sources for kernel version:"
289 qeinfo " ${KV_FULL}" 509 qeinfo " ${KV_FULL}"
290 510
291 if [ ! -s "${KV_OUT_DIR}/.config" ]
292 then
293 qeerror "Could not find a usable .config in the kernel source directory."
294 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
295 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
296 qeerror "it points to the necessary object directory so that it might find .config."
297 return 1
298 fi
299
300 return 0 511 return 0
301} 512}
302 513
514# @FUNCTION: get_running_version
515# @DESCRIPTION:
516# It gets the version of the current running kernel and the result is the same as get_version() if the
517# function can find the sources.
303get_running_version() { 518get_running_version() {
304 KV_FULL=$(uname -r) 519 KV_FULL=$(uname -r)
305 520
306 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then 521 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
307 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source) 522 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
326 541
327 542
328# ebuild check functions 543# ebuild check functions
329# --------------------------------------- 544# ---------------------------------------
330 545
546# @FUNCTION: check_kernel_built
547# @DESCRIPTION:
548# This function verifies that the current kernel sources have been already prepared otherwise it dies.
331check_kernel_built() { 549check_kernel_built() {
332 # if we haven't determined the version yet, we need too. 550 # if we haven't determined the version yet, we need to
551 require_configured_kernel
333 get_version; 552 get_version
334 553
335 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ] 554 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
336 then 555 then
337 eerror "These sources have not yet been prepared." 556 eerror "These sources have not yet been prepared."
338 eerror "We cannot build against an unprepared tree." 557 eerror "We cannot build against an unprepared tree."
339 eerror "To resolve this, please type the following:" 558 eerror "To resolve this, please type the following:"
345 eerror "Then please try merging this module again." 564 eerror "Then please try merging this module again."
346 die "Kernel sources need compiling first" 565 die "Kernel sources need compiling first"
347 fi 566 fi
348} 567}
349 568
569# @FUNCTION: check_modules_supported
570# @DESCRIPTION:
571# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
350check_modules_supported() { 572check_modules_supported() {
351 # if we haven't determined the version yet, we need too. 573 # if we haven't determined the version yet, we need too.
574 require_configured_kernel
352 get_version; 575 get_version
353 576
354 if ! linux_chkconfig_builtin "MODULES" 577 if ! linux_chkconfig_builtin "MODULES"
355 then 578 then
356 eerror "These sources do not support loading external modules." 579 eerror "These sources do not support loading external modules."
357 eerror "to be able to use this module please enable \"Loadable modules support\"" 580 eerror "to be able to use this module please enable \"Loadable modules support\""
358 eerror "in your kernel, recompile and then try merging this module again." 581 eerror "in your kernel, recompile and then try merging this module again."
359 die "No support for external modules in ${KV_FULL} config" 582 die "No support for external modules in ${KV_FULL} config"
360 fi 583 fi
361} 584}
362 585
586# @FUNCTION: check_extra_config
587# @DESCRIPTION:
588# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
589# the prefix ~ is not used) doesn't satisfy the directive.
363check_extra_config() { 590check_extra_config() {
364 local config negate error local_error i n temp_config 591 local config negate die error reworkmodulenames
592 local soft_errors_count=0 hard_errors_count=0 config_required=0
365 593
366 # if we haven't determined the version yet, we need too. 594 # if we haven't determined the version yet, we need to
367 get_version; 595 get_version
368 596
369 einfo "Checking for suitable kernel configuration options" 597 # Determine if we really need a .config. The only time when we don't need
598 # one is when all of the CONFIG_CHECK options are prefixed with "~".
370 for config in ${CONFIG_CHECK} 599 for config in ${CONFIG_CHECK}
371 do 600 do
372 negate="${config:0:1}" 601 if [[ "${config:0:1}" != "~" ]]; then
373 if [ "${negate}" == "!" ]; 602 config_required=1
374 then 603 break
604 fi
605 done
606
607 if [[ ${config_required} == 0 ]]; then
608 # In the case where we don't require a .config, we can now bail out
609 # if the user has no .config as there is nothing to do. Otherwise
610 # code later will cause a failure due to missing .config.
611 if ! linux_config_exists; then
612 ewarn "Unable to check for the following kernel config options due"
613 ewarn "to absence of any configured kernel sources:"
614 for config in ${CONFIG_CHECK}; do
615 ewarn " - ${config#\~}"
616 done
617 ewarn "You're on your own to make sure they are set if needed."
618 return 0
619 fi
620 else
621 require_configured_kernel
622 fi
623
624 einfo "Checking for suitable kernel configuration options..."
625
626 for config in ${CONFIG_CHECK}
627 do
628 # if we specify any fatal, ensure we honor them
629 die=1
630 error=0
631 negate=0
632 reworkmodulenames=0
633
634 if [[ ${config:0:1} == "~" ]]; then
635 die=0
375 config="${config:1}" 636 config=${config:1}
637 elif [[ ${config:0:1} == "@" ]]; then
638 die=0
639 reworkmodulenames=1
640 config=${config:1}
641 fi
642 if [[ ${config:0:1} == "!" ]]; then
643 negate=1
644 config=${config:1}
645 fi
646
647 if [[ ${negate} == 1 ]]; then
648 linux_chkconfig_present ${config} && error=2
649 elif [[ ${reworkmodulenames} == 1 ]]; then
650 local temp_config="${config//*:}" i n
651 config="${config//:*}"
376 if linux_chkconfig_present ${config} 652 if linux_chkconfig_present ${config}; then
377 then 653 for i in ${MODULE_NAMES}; do
654 n="${i//${temp_config}}"
655 [[ -z ${n//\(*} ]] && \
656 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
657 done
658 error=2
659 fi
660 else
661 linux_chkconfig_present ${config} || error=1
662 fi
663
664 if [[ ${error} > 0 ]]; then
665 local report_func="eerror" local_error
666 local_error="ERROR_${config}"
667 local_error="${!local_error}"
668
669 if [[ -z "${local_error}" ]]; then
670 # using old, deprecated format.
378 local_error="${config}_ERROR" 671 local_error="${config}_ERROR"
379 local_error="${!local_error}" 672 local_error="${!local_error}"
380 [ -n "${local_error}" ] && eerror " ${local_error}" || \
381 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
382 error=1
383 fi 673 fi
384 elif [ "${negate}" == "@" ]; 674 if [[ ${die} == 0 && -z "${local_error}" ]]; then
385 then 675 #soft errors can be warnings
386 # we never call this unless we are using MODULE_NAMES
387
388 config="${config:1}"
389 temp_config="${config//*:}"
390 config="${config//:*}"
391 if linux_chkconfig_present ${config}
392 then
393 local_error="${config}_ERROR" 676 local_error="WARNING_${config}"
394 local_error="${!local_error}" 677 local_error="${!local_error}"
395 [ -n "${local_error}" ] && eerror " ${local_error}" || \ 678 if [[ -n "${local_error}" ]] ; then
396 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is." 679 report_func="ewarn"
397 680 fi
398 for i in ${MODULE_NAMES}
399 do
400 n="${i//${temp_config}}"
401 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
402 done
403 error=0
404 fi 681 fi
405 else 682
406 if ! linux_chkconfig_present ${config}
407 then
408 # Support the new syntax first.
409 local_error="ERROR_${config}"
410 local_error="${!local_error}"
411
412 # then fall back on the older syntax.
413 if [[ -z ${local_error} ]] ; then 683 if [[ -z "${local_error}" ]]; then
414 local_error="${config}_ERROR" 684 [[ ${error} == 1 ]] \
415 local_error="${!local_error}" 685 && local_error="is not set when it should be." \
686 || local_error="should not be set. But it is."
687 local_error="CONFIG_${config}:\t ${local_error}"
416 fi 688 fi
417 689 if [[ ${die} == 0 ]]; then
418 [[ -n ${local_error} ]] && eerror " ${local_error}" || \ 690 ${report_func} " ${local_error}"
419 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't" 691 soft_errors_count=$[soft_errors_count + 1]
420 error=1 692 else
693 ${report_func} " ${local_error}"
694 hard_errors_count=$[hard_errors_count + 1]
421 fi 695 fi
422 fi 696 fi
423 done 697 done
424 698
425 if [ "${error}" == 1 ] ; 699 if [[ ${hard_errors_count} > 0 ]]; then
426 then
427 eerror "Please check to make sure these options are set correctly." 700 eerror "Please check to make sure these options are set correctly."
701 eerror "Failure to do so may cause unexpected problems."
428 eerror "Once you have satisfied these options, please try merging" 702 eerror "Once you have satisfied these options, please try merging"
429 eerror "this package again." 703 eerror "this package again."
430 die "Incorrect kernel configuration options" 704 die "Incorrect kernel configuration options"
705 elif [[ ${soft_errors_count} > 0 ]]; then
706 ewarn "Please check to make sure these options are set correctly."
707 ewarn "Failure to do so may cause unexpected problems."
708 else
709 eend 0
431 fi 710 fi
432} 711}
433 712
434check_zlibinflate() { 713check_zlibinflate() {
435 # if we haven't determined the version yet, we need too. 714 # if we haven't determined the version yet, we need to
715 require_configured_kernel
436 get_version; 716 get_version
437 717
438 # although I restructured this code - I really really really dont support it! 718 # although I restructured this code - I really really really dont support it!
439 719
440 # bug #27882 - zlib routines are only linked into the kernel 720 # bug #27882 - zlib routines are only linked into the kernel
441 # if something compiled into the kernel calls them 721 # if something compiled into the kernel calls them
442 # 722 #
443 # plus, for the cloop module, it appears that there's no way 723 # plus, for the cloop module, it appears that there's no way
444 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 724 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
445 # is on 725 # is on
446 726
447local INFLATE 727 local INFLATE
448local DEFLATE 728 local DEFLATE
449 729
450 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 730 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
451 731
452 ebegin "checking ZLIB_INFLATE" 732 ebegin "checking ZLIB_INFLATE"
453 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 733 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
454 eend $? 734 eend $?
455 [ "$?" != 0 ] && die 735 [ "$?" != 0 ] && die
456 736
457 ebegin "checking ZLIB_DEFLATE" 737 ebegin "checking ZLIB_DEFLATE"
458 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 738 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
459 eend $? 739 eend $?
460 [ "$?" != 0 ] && die 740 [ "$?" != 0 ] && die
461 741
462
463 local LINENO_START 742 local LINENO_START
464 local LINENO_END 743 local LINENO_END
465 local SYMBOLS 744 local SYMBOLS
466 local x 745 local x
467 746
468 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 747 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
469 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 748 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
470 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 749 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
471 (( LINENO_END = $LINENO_END - 1 )) 750 (( LINENO_END = $LINENO_END - 1 ))
472 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 751 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
478 # we have a winner! 757 # we have a winner!
479 einfo "${x} ensures zlib is linked into your kernel - excellent" 758 einfo "${x} ensures zlib is linked into your kernel - excellent"
480 return 0 759 return 0
481 fi 760 fi
482 done 761 done
483 762
484 eerror 763 eerror
485 eerror "This kernel module requires ZLIB library support." 764 eerror "This kernel module requires ZLIB library support."
486 eerror "You have enabled zlib support in your kernel, but haven't enabled" 765 eerror "You have enabled zlib support in your kernel, but haven't enabled"
487 eerror "enabled any option that will ensure that zlib is linked into your" 766 eerror "enabled any option that will ensure that zlib is linked into your"
488 eerror "kernel." 767 eerror "kernel."
502} 781}
503 782
504################################ 783################################
505# Default pkg_setup 784# Default pkg_setup
506# Also used when inheriting linux-mod to force a get_version call 785# Also used when inheriting linux-mod to force a get_version call
507 786# @FUNCTION: linux-info_pkg_setup
787# @DESCRIPTION:
788# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
789# to support the options specified in CONFIG_CHECK (if not null)
508linux-info_pkg_setup() { 790linux-info_pkg_setup() {
509 get_version || die "Unable to calculate Linux Kernel version" 791 get_version
792 if [[ $rc -ne 0 ]]; then
793 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
794 get_running_version
795 fi
796
797 if kernel_is 2 4; then
798 if [ "$( gcc-major-version )" -eq "4" ] ; then
799 echo
800 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
801 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
802 echo
803 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
804 ewarn "newer kernel that supports gcc-4."
805 echo
806 ewarn "Also be aware that bugreports about gcc-4 not working"
807 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
808 echo
809 epause 10
810 fi
811 fi
812
510 [ -n "${CONFIG_CHECK}" ] && check_extra_config; 813 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
511} 814}

Legend:
Removed from v.1.24  
changed lines
  Added in v.1.62

  ViewVC Help
Powered by ViewVC 1.1.20